/*****************************************************************************
                 Copyright (c) 1995-6  IONA Technologies Ltd.
                          All Rights Reserved
 
        THIS IS UNPUBLISHED PROPRIETARY SOURCE CODE OF Iona Technologies
 
        The copyright notice above does not evidence any
        actual or intended publication of such source code.
 
        The information contained herein is TRADE SECRET and 
        PROPRIETARY INFORMATION of IONA Technologies Ltd.and is not to
        be disclosed without the express written consent of IONA
        Technologies Ltd.
 
*****************************************************************************/

//
// class netscape.security.PrivilegeManager
//
// Original Author: Justin Mason
//
// This is a pain -- since Netscape's capabilities model requires that these
// functions be called in the stack frame where the capabilities are required,
// we can't simply check the browser version and call a function to do it,
// which would avoid having to provide this skeleton class. See David Hopwood's
// message reproduced at the end of this file.
//
// When Communicator _is_ in use, this class is not downloaded and Netscape
// will use its own internal version.
//
// As Dave pointed out -- OrbixWeb now has a file with more comments than code!
//
// Wed Jul 23 15:47:32 BST 1997 jmason

package netscape.security;
import java.lang.Exception;

public final class PrivilegeManager {
    public static void enablePrivilege(String name)
    		throws Exception
    		{ throw new Exception("privileges unsupported"); }
    public static void revertPrivilege(String name)
    		throws Exception
		{ throw new Exception("privileges unsupported"); }
}

//---------------------------------------------------------------------------
// From David Hopwood <hopwood@zetnet.co.uk>
// Date: Mon, 30 Jun 1997 18:05:17 +0100
// Newsgroups: comp.lang.java.security
// 
// In message <> meijer <> writes: 
// 
// > David Hopwood wrote:
// > > [ wrote:]
// > > > Your example is most clarifying! Do you by any chance
// > > > also know how to make it all work with Netscape 4.0x,
// > > > Internet Explorer 3.x (4.0 beta?) *and* Netscape 3.x?
// > > 
// > > There is a kludgy way to do that: write some JavaScript (or whatever) that
// > > displays a different page if the user agent corresponds to Netscape 3.x.
// > > 
// > > In the NS3.x version of your applet, replace each call to
// > > "PrivilegeManager.enablePrivilege(anything)" with
// > > "SecurityManager.setScopePermission()", and
// > > "PrivilegeManager.revertPrivilege(anything)" with
// > > "SecurityManager.resetScopePermission()".
// > > 
// > > In the version for all other browsers, use the dummy PrivilegeManager as
// > > described above, and
// 
// Ignore the following bit, since the question was about local code rather than
// signed code:
// 
// > > include a signed .cab file as described in Microsoft's
// > > documentation (MSIE will look at the .cab file in preference to downloading
// > > classfiles individually).
// 
// There is no need to include a .cab file for MSIE if system classes are used
// (i.e. classes loaded from the CLASSPATH, rather than from an URL).
// 
// [...]
// > Thank you, David! This is awful indeed, but what you describe
// > should work. I had hoped that one of the System.getProperty()'s 
// > would allow making a distinction between NS 3.x and NS 4.0:
// > I didn't check this yet (no NS 4.0 where I'm writing this), 
// > but wondered whether the partial JDK 1.1 support would have 
// > led to a non-"1.02" response from System.getProperty("java.version") 
// > in NS 4.0. If not, then things can indeed get rather ugly!
// 
// You can work out exactly what is running an applet from a combination
// of java.version, browser.vendor and browser.version, but that doesn't
// help directly - see below.
// 
// If you want to avoid JavaScript, it is possible to use an applet that
// calls showDocument() instead (i.e. three applets in total).
// 
// > A better way might be to use JavaScript ("onLoad"?) to 
// > communicate the browser version to the applet. JavaScript 
// > *does* know the version, and communication from JavaScript
// > to Java works well in IE 3.x, NS 3.x and NS 4.0x. [I'm
// > not sure about the timing of "onLoad" versus the applet
// > start() methods, though, as I never used it for this.]
// 
// > Then having that info within the (single) applet in
// > this single page solution, one can make the appropriate
// > switches for PrivilegeManager, I think.
// 
// You'd think so, but unfortunately not. There are two problems: one is that
// enable/disablePrivilege are not quite like ordinary methods; they must
// be called in the same stack frame as the code that requires the privilege
// to be granted. For example this would not work:
// 
// class PortablePrivilegeManager {
//    public static enablePrivilege(String priv) {
//        // call PrivilegeManager.enablePrivilege or
//        // SecurityManager.setScopePermission as necessary
//    }
//    public static disablePrivilege(String priv) { ... }
// }
// 
// because this only grants extra privileges to PortablePrivilegeManager,
// not to the code that calls it.
// 
// The second is that JIT compilers (or at least, the ones in Netscape and IE)
// cannot correctly load classes that refer to static methods that do not
// exist at load-time. I.e. the foo() and bar() methods below will work as
// intended when run in a Java interpreter, but not in any of the Symantec,
// Borland or Microsoft JIT compilers:
// 
// class MyClass {
//    public void foo() {
//        try {
// 	   SecurityManager.setScopePermission();
//        } catch (NoSuchMethodError e) { /* do nothing */ }
//        ...
//    }
// 
//    public void bar() {
//        if (any_non_constant_boolean_expression) {
// 	   SecurityManager.setScopePermission();
//        }
//        ...
//    }
// }
// 
// If SecurityManager.setScopePermission does not exist, these compilers will
// invalidate MyClass before any of its code is run.
// 
// The only way I know of to get something like this to work is to dynamically
// load different versions of the code that needs extra permissions (using
// Class.forName), and only call it via interface methods. This is probably
// more difficult to maintain than having two versions of the applet. I also
// don't recommend it for security reasons: if your applet can do this, so can
// any untrusted code that is run with the same CLASSPATH.
// 
// David Hopwood
